import random
from my_queue import Queue
from car import Car
from carwash import CarWash


def simulate_car_wash(num_minutes, chance):
    car_wash = CarWash()
    queue = Queue()
    total_time, total_cars = 0, 0

    for cur_minute in range(num_minutes):
        if random.random() < chance:
            new_car = Car(cur_minute)
            queue.enqueue(new_car)
            print('queued a new car with {} dirt'.format(new_car.get_dirt()))

        if not car_wash.busy() and not queue.is_empty():
            new_car = queue.dequeue()
            car_wash.start_next(new_car)
            total_cars += 1
            total_time += new_car.waiting_time(cur_minute)
            print('started to wash a car with {} dirt'.format(new_car.get_dirt()))

        print("Time: {} minutes, queued cars: {}".format(cur_minute, queue.size()))
        print(str(car_wash))

        car_wash.tick()
    print(f"Average waiting time: {total_time / total_cars}")


if __name__ == "__main__":
    simulate_car_wash(100, 0.2)
