class Stack:
    def __init__(self):
        self.items = []

    # Θ(1)
    def is_empty(self):
        return self.items == []

    # Θ(1)
    def push(self, item):
        self.items.append(item)

    # Θ(1)
    def pop(self):
        return self.items.pop()

    # Θ(1)
    def peek(self):
        return self.items[-1]

    # Θ(1)
    def size(self):
        return len(self.items)


# alternatywna implementacja stosu
class Stack1:
    def __init__(self):
        self.items = []

    # Θ(1)
    def is_empty(self):
        return self.items == []

    # Θ(n)
    def push(self, item):
        self.items.insert(0, item)

    # Θ(n)
    def pop(self):
        return self.items.pop(0)

    # Θ(1)
    def peek(self):
        return self.items[0]

    # Θ(1)
    def size(self):
        return len(self.items)


if __name__ == "__main__":
    s = Stack() # s -> []
    print(s.is_empty()) # True
    s.push('A') # s -> ['A']
    s.push('B') # s -> ['A', 'B']
    s.push('C') # s -> ['A', 'B', 'C']
    s.pop()     # s -> ['A', 'B']
    s.push('Z') # s -> ['A', 'B', 'Z']
    s.push(100) # s -> ['A', 'B', 'Z', 100]
